// Codes that must add at the head of main.js
(function () {
    if (typeof window.jsb === 'object') {
        // Create download path if not exist.
        var hotPath = jsb.fileUtils.getWritablePath() + "DaxiaWd"
        if (!jsb.fileUtils.isDirectoryExist(hotPath)) {
            console.log("--------main.js new download path: ", hotPath)
            jsb.fileUtils.createDirectory(hotPath)
        }

        // Add search paths
        console.log("--------main.js add search paths--------")
        var newPaths = [hotPath + "/"]
        var searchPaths = jsb.fileUtils.getSearchPaths()
        Array.prototype.unshift.apply(searchPaths, newPaths)
        jsb.fileUtils.setSearchPaths(searchPaths)

        // Re-add search paths and fix code for exception case
        var hotUpdateSearchPaths = localStorage.getItem('HotUpdateSearchPaths')
        if (hotUpdateSearchPaths) {
            var paths = JSON.parse(hotUpdateSearchPaths)
            jsb.fileUtils.setSearchPaths(paths)

            var fileList = []
            var storagePath = paths[0] || ''
            var tempPath = storagePath + '_temp/'
            var baseOffset = tempPath.length

            if (jsb.fileUtils.isDirectoryExist(tempPath) && !jsb.fileUtils.isFileExist(tempPath + 'project.manifest.temp')) {
                jsb.fileUtils.listFilesRecursively(tempPath, fileList)
                fileList.forEach(srcPath => {
                    var relativePath = srcPath.substr(baseOffset)
                    var dstPath = storagePath + relativePath

                    if (srcPath[srcPath.length] == '/') {
                        jsb.fileUtils.createDirectory(dstPath)
                    }
                    else {
                        if (jsb.fileUtils.isFileExist(dstPath)) {
                            jsb.fileUtils.removeFile(dstPath)
                        }
                        jsb.fileUtils.renameFile(srcPath, dstPath)
                    }
                })
                jsb.fileUtils.removeDirectory(tempPath)
            }
        }

        let newSearchPaths = jsb.fileUtils.getSearchPaths()
        let initPaths = JSON.stringify(newSearchPaths)
        console.log("--------main.js search paths:", initPaths)
    }
})();

// package build version for hot update, plus value for each new app audit
window.BUILD_VERSION = "1"

// SystemJS support.
window.self = window;
require("src/system.bundle.js");

const importMapJson = jsb.fileUtils.getStringFromFile("src/import-map.json");
const importMap = JSON.parse(importMapJson);
System.warmup({
    importMap,
    importMapUrl: 'src/import-map.json',
    defaultHandler: (urlNoSchema) => {
        require(urlNoSchema.startsWith('/') ? urlNoSchema.substr(1) : urlNoSchema);
    },
});

System.import('./src/application.js')
.then(({ Application }) => {
    console.log("--------main.js new Application--------")
    return new Application();
}).then((application) => {
    return System.import('cc').then((cc) => {
        require('jsb-adapter/engine-adapter.js');
        console.log("--------main.js init Application--------")
        return application.init(cc);
    }).then(() => {
        console.log("--------main.js start Application--------")
        return application.start();
    });
}).catch((err) => {
    console.error(err.toString() + ', stack: ' + err.stack);
});
